package CaptiveSupply;

import java.util.*;

import tools.*;

public class SpotMarket {

	double AveragePrice[];
	double PreviousAveragePrice[];
	double[] TotalDemandQuantity;	
	double[] PreviousTotalQuantity;
	
	SpotMarket(ModelCS m){
		AveragePrice=new double[m.ParallelMarket] ;
		PreviousAveragePrice=new double[m.ParallelMarket];
		TotalDemandQuantity=new double[m.ParallelMarket];
		PreviousTotalQuantity=new double[m.ParallelMarket];
	}
		
	void DirectMarketInitialzation(ModelCS m,Buyer[] p, Seller[] f){
		
		Arrays.fill(AveragePrice,0);
		Arrays.fill(PreviousAveragePrice, 0);
	}
	
public void MakeADeal(Buyer[] b, Seller[] s,ModelCS m,MarketInformationCenter MIC,int week,int pm, int e){
	TotalDemandQuantity[pm]=0;
	double TotalContractNo=0;

	for(int i=0;i<b.length;i++)TotalContractNo+=b[i].ContractNo[pm];
			
	for(int i=0;i<b.length;i++){
		b[i].Capacity[pm]=b[i].CapacityRatio[pm]*m.BuyerCapacity;
		TotalDemandQuantity[pm]+=b[i].Capacity[pm];
	}
	
	double TotalSupply=(m.TotalsellerNumber-TotalContractNo)*MIC.PreviousAveragePrice[pm];
	AveragePrice[pm]=TotalDemandQuantity[pm]/(double)(m.TotalsellerNumber-TotalContractNo);
	if(TotalDemandQuantity[pm]>TotalSupply)	{
		
		for(int i=0;i<b.length;i++)	b[i].Capacity[pm]=m.BuyerCapacity*b[i].CapacityRatio[pm]*TotalSupply/TotalDemandQuantity[pm];		
		TotalDemandQuantity[pm]=TotalSupply;
	}
	
	if(AveragePrice[pm]<1)AveragePrice[pm]=PreviousAveragePrice[pm];
	if(AveragePrice[pm]>100)AveragePrice[pm]=100;
	MIC.AveragePrice[pm]=AveragePrice[pm];  
	MIC.PreviousAveragePrice[pm]=AveragePrice[pm];  
	

   }//end method;
    
}



